using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using System.IO;
using System.IO.IsolatedStorage;

namespace Demo_3_IsolatedStorage
{
	/// <summary>
	/// Summary description for NotesUserControl.
	/// </summary>
	public class NotesUserControl : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Button buttonLoad;
		private System.Windows.Forms.TextBox textBoxNotes;
		private System.Windows.Forms.Button buttonSave;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public NotesUserControl()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitComponent call

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if( components != null )
					components.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonLoad = new System.Windows.Forms.Button();
			this.textBoxNotes = new System.Windows.Forms.TextBox();
			this.buttonSave = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonLoad
			// 
			this.buttonLoad.Location = new System.Drawing.Point(32, 160);
			this.buttonLoad.Name = "buttonLoad";
			this.buttonLoad.TabIndex = 0;
			this.buttonLoad.Text = "Load";
			this.buttonLoad.Click += new System.EventHandler(this.buttonLoad_Click);
			// 
			// textBoxNotes
			// 
			this.textBoxNotes.Location = new System.Drawing.Point(8, 8);
			this.textBoxNotes.Multiline = true;
			this.textBoxNotes.Name = "textBoxNotes";
			this.textBoxNotes.Size = new System.Drawing.Size(248, 144);
			this.textBoxNotes.TabIndex = 1;
			this.textBoxNotes.Text = "";
			// 
			// buttonSave
			// 
			this.buttonSave.Location = new System.Drawing.Point(152, 160);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.TabIndex = 2;
			this.buttonSave.Text = "Save";
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// MyUserControl
			// 
			this.BackColor = System.Drawing.Color.LightGray;
			this.Controls.Add(this.buttonSave);
			this.Controls.Add(this.textBoxNotes);
			this.Controls.Add(this.buttonLoad);
			this.Name = "MyUserControl";
			this.Size = new System.Drawing.Size(264, 192);
			this.ResumeLayout(false);

		}
		#endregion

		private void buttonLoad_Click(object sender, System.EventArgs e)
		{
			try
			{
				string notes = LoadNotes("notes.txt");
				textBoxNotes.Text = notes;
				MessageBox.Show("Notes loaded.", "Info");
			}
			catch (Exception)
			{
				MessageBox.Show("Can not load notes from IsolatedStorage!", "Error");
			}
		}

		private void buttonSave_Click(object sender, System.EventArgs e)
		{
			try
			{
				string notes = textBoxNotes.Text;
				SaveNotes("notes.txt", notes);
				MessageBox.Show("Notes saved.", "Info");
			}
			catch (Exception)
			{
				MessageBox.Show("Can not save notes to IsolatedStorage!", "Error");
			}
		}

		private string LoadNotes(string aFileName)
		{
			IsolatedStorageFile isoStore = IsolatedStorageFile.GetStore(
			    IsolatedStorageScope.User | IsolatedStorageScope.Assembly, null, null);
			using (isoStore)
			{
				IsolatedStorageFileStream stream = new IsolatedStorageFileStream(
					aFileName, FileMode.Open, FileAccess.Read, isoStore);
				using (stream)
				{
					using (StreamReader reader = new StreamReader(stream))
					{
						string contents = reader.ReadToEnd();
						return contents;
					}
				}
			}
		}

		private void SaveNotes(string aFileName, string aNotes)
		{
			IsolatedStorageFile isoStore = IsolatedStorageFile.GetStore(
				IsolatedStorageScope.User | IsolatedStorageScope.Assembly, null, null);
			using (isoStore)
			{
				IsolatedStorageFileStream stream = new IsolatedStorageFileStream(
					aFileName, FileMode.Create, FileAccess.Write, isoStore);
				using (stream)
				{
					using (StreamWriter writer = new StreamWriter(stream))
					{
						writer.Write(aNotes);
					}
				}
			}
		}
	}
}
